Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/context_nemo.xml
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/context_nemo.xml	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/context_nemo.xml	(revision 13892)
@@ -11,5 +11,5 @@
        <variable id="ref_month" type="int"> 01 </variable>
        <variable id="ref_day"   type="int"> 01 </variable>
-       <variable id="rau0"      type="float" > 1026.0 </variable>
+       <variable id="rho0"      type="float" > 1026.0 </variable>
        <variable id="cpocean"   type="float" > 3991.86795711963 </variable>
        <variable id="convSpsu"  type="float" > 0.99530670233846  </variable>
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg	(revision 13892)
@@ -21,5 +21,4 @@
    nn_it000    =       1   !  first time step
    nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
-   !nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
    nn_stock    =    6120   !  frequency of creation of a restart file (modulo referenced to 1)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg	(revision 13892)
@@ -21,5 +21,4 @@
    nn_it000    =       1   !  first time step
    nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
-   !nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
    nn_stock    =    1080   !  frequency of creation of a restart file (modulo referenced to 1)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg	(revision 13892)
@@ -21,5 +21,4 @@
    nn_it000    =       1   !  first time step
    nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
-   !nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
    nn_stock    =    6120   !  frequency of creation of a restart file (modulo referenced to 1)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg	(revision 13892)
@@ -21,5 +21,4 @@
    nn_it000    =       1   !  first time step
    nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
-   !nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
    nn_stock    =    1080   !  frequency of creation of a restart file (modulo referenced to 1)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg	(revision 13892)
@@ -20,5 +20,4 @@
    cn_exp      =   "OVF_zps_FCT2_flux_ubs"  !  experience name
    nn_it000    =       1   !  first time step
-   !nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
    nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 13892)
@@ -105,6 +105,6 @@
 !!                                                                    !!
 !!   namdrg        top/bottom drag coefficient                          (default: NO selection)
-!!   namdrg_top    top    friction                                      (ln_OFF=F & ln_isfcav=T)
-!!   namdrg_bot    bottom friction                                      (ln_OFF=F)
+!!   namdrg_top    top    friction                                      (ln_drg_OFF=F & ln_isfcav=T)
+!!   namdrg_bot    bottom friction                                      (ln_drg_OFF=F)
 !!   nambbc        bottom temperature boundary condition                (default: OFF)
 !!   nambbl        bottom boundary layer scheme                         (default: OFF)
@@ -114,5 +114,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -136,5 +136,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
@@ -289,5 +289,4 @@
 !!                                                                    !!
 !!   namtrd       dynamics and/or tracer trends                         (default: OFF)
-!!   namptr       Poleward Transport Diagnostics                        (default: OFF)
 !!   namhsb       Heat and salt budgets                                 (default: OFF)
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg	(revision 13892)
@@ -20,5 +20,4 @@
    cn_exp      =   "OVF_zps_FCT4_vect_een"  !  experience name
    nn_it000    =       1   !  first time step
-   !nn_itend    =    6120  ! here 17h of simulation  (=6120 time-step) 
    nn_itend    =    5760   ! here 16h of simulation  (=5760 time-step) abort after 5802 for zps: pb of physics conditions
    nn_istate   =       0   !  output the initial state (1) or not (0)
@@ -71,5 +70,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
@@ -82,5 +81,5 @@
 !-----------------------------------------------------------------------
    ln_seos     = .true.         !  = Use simplified equation of state (S-EOS)
-   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                             !  rd(T,S,Z)*rho0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (for simplified equation of state)
    rn_b0       =  0.          !  saline  expension coefficient (for simplified equation of state)
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_hgr.F90
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_hgr.F90	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_hgr.F90	(revision 13892)
@@ -13,5 +13,5 @@
    !!   usr_def_hgr    : initialize the horizontal mesh for OVERFLOW configuration
    !!----------------------------------------------------------------------
-   USE dom_oce  ,  ONLY: nimpp, njmpp       ! ocean space and time domain
+   USE dom_oce
    USE par_oce         ! ocean space and time domain
    USE phycst          ! physical constants
@@ -74,14 +74,14 @@
       !                       !==  grid point position  ==!   (in kilometers)
       zfact = rn_dx * 1.e-3         ! conversion in km
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !                       ! longitude
-         plamt(ji,jj) = zfact * (  - 0.5 + REAL( ji-1 + nimpp-1 , wp )  )  
-         plamu(ji,jj) = zfact * (          REAL( ji-1 + nimpp-1 , wp )  )
+         plamt(ji,jj) = zfact * (  - 0.5 + REAL( mig0_oldcmp(ji)-1 , wp )  )  
+         plamu(ji,jj) = zfact * (          REAL( mig0_oldcmp(ji)-1 , wp )  )
          plamv(ji,jj) = plamt(ji,jj)
          plamf(ji,jj) = plamu(ji,jj)
          !                       ! latitude
-         pphit(ji,jj) = zfact * (  - 0.5 + REAL( jj-1 + njmpp-1 , wp )  )
+         pphit(ji,jj) = zfact * (  - 0.5 + REAL( mjg0_oldcmp(jj)-1 , wp )  )
          pphiu(ji,jj) = pphit(ji,jj)
-         pphiv(ji,jj) = zfact * (          REAL( jj-1 + njmpp-1 , wp )  )
+         pphiv(ji,jj) = zfact * (          REAL( mjg0_oldcmp(jj)-1 , wp )  )
          pphif(ji,jj) = pphiv(ji,jj)
       END_2D
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_nam.F90
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_nam.F90	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_nam.F90	(revision 13892)
@@ -14,5 +14,4 @@
    !!   usr_def_hgr   : initialize the horizontal mesh 
    !!----------------------------------------------------------------------
-   USE dom_oce  , ONLY: nimpp , njmpp            ! i- & j-indices of the local domain
    USE dom_oce  , ONLY: ln_zco, ln_zps, ln_sco   ! flag of type of coordinate
    USE par_oce        ! ocean space and time domain
@@ -86,6 +85,6 @@
       WRITE(numout,*) '      vertical   resolution                    rn_dz  = ', rn_dz, ' meters'
       WRITE(numout,*) '      OVERFLOW domain = 200 km x 3 grid-points x 2000 m'
-      WRITE(numout,*) '         resulting global domain size :        jpiglo = ', kpi
-      WRITE(numout,*) '                                               jpjglo = ', kpj
+      WRITE(numout,*) '         resulting global domain size :        Ni0glo = ', kpi
+      WRITE(numout,*) '                                               Nj0glo = ', kpj
       WRITE(numout,*) '                                               jpkglo = ', kpk
       !
Index: NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90
===================================================================
--- NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 12986)
+++ NEMO/branches/2020/dev_r12985_TOP-04_IMMERSE_BGC_interface/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 13892)
@@ -15,6 +15,6 @@
    !!---------------------------------------------------------------------
    USE oce            ! ocean variables
-   USE dom_oce ,  ONLY: mi0, mi1, nimpp, njmpp   ! ocean space and time domain
-   USE dom_oce ,  ONLY: glamt                    ! ocean space and time domain
+   USE dom_oce ,  ONLY: mi0, mi1   ! ocean space and time domain
+   USE dom_oce ,  ONLY: glamt      ! ocean space and time domain
    USE usrdef_nam     ! User defined : namelist variables
    !
@@ -184,5 +184,5 @@
             pe3vw(:,:,jk) = pe3w_1d (jk)
          END DO
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ik = k_bot(ji,jj)
             pdepw(ji,jj,ik+1) = MIN( zht(ji,jj) , pdepw_1d(ik+1) )