Index: NEMO/branches/2020/tickets_icb_1900/src/OCE/CRS/crsdom.F90
===================================================================
--- NEMO/branches/2020/tickets_icb_1900/src/OCE/CRS/crsdom.F90	(revision 13277)
+++ NEMO/branches/2020/tickets_icb_1900/src/OCE/CRS/crsdom.F90	(revision 13899)
@@ -73,5 +73,5 @@
   
             
-      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+      IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
          IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
             je_2 = mje_crs(2)   ;  ij = je_2
@@ -81,5 +81,5 @@
       ENDIF
       DO jk = 1, jpkm1
-         DO ji = 2, nlei_crs  
+         DO ji = 2, Nie0_crs  
             ijis = mis_crs(ji)  ;  ijie = mie_crs(ji)    
             !          
@@ -101,7 +101,7 @@
       !
       DO jk = 1, jpkm1
-         DO ji = 2, nlei_crs  
+         DO ji = 2, Nie0_crs  
             ijis = mis_crs(ji)     ;   ijie = mie_crs(ji)       
-            DO jj = 3, nlej_crs
+            DO jj = 3, Nje0_crs
                ijjs = mjs_crs(jj)  ;   ijje = mje_crs(jj)
                           
@@ -168,7 +168,7 @@
       SELECT CASE ( cd_type )
          CASE ( 'T' )
-            DO jj =  nldj_crs, nlej_crs
+            DO jj =  Njs0_crs, Nje0_crs
                ijjs = mjs_crs(jj) + mybinctr
-               DO ji = 2, nlei_crs
+               DO ji = 2, Nie0_crs
                   ijis = mis_crs(ji) + mxbinctr 
                   p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
@@ -177,7 +177,7 @@
             ENDDO
          CASE ( 'U' )
-            DO jj =  nldj_crs, nlej_crs
+            DO jj =  Njs0_crs, Nje0_crs
                ijjs = mjs_crs(jj) + mybinctr                  
-               DO ji = 2, nlei_crs
+               DO ji = 2, Nie0_crs
                   ijis = mis_crs(ji)
                   p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
@@ -186,7 +186,7 @@
             ENDDO
          CASE ( 'V' )
-            DO jj =  nldj_crs, nlej_crs
+            DO jj =  Njs0_crs, Nje0_crs
                ijjs = mjs_crs(jj)
-               DO ji = 2, nlei_crs
+               DO ji = 2, Nie0_crs
                   ijis = mis_crs(ji) + mxbinctr 
                   p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
@@ -195,7 +195,7 @@
             ENDDO
          CASE ( 'F' )
-            DO jj =  nldj_crs, nlej_crs
+            DO jj =  Njs0_crs, Nje0_crs
                ijjs = mjs_crs(jj)
-               DO ji = 2, nlei_crs
+               DO ji = 2, Nie0_crs
                   ijis = mis_crs(ji)
                   p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
@@ -212,5 +212,5 @@
       SELECT CASE ( cd_type )
          CASE ( 'T', 'V' )
-            DO ji = 2, nlei_crs
+            DO ji = 2, Nie0_crs
                ijis = mis_crs(ji) + mxbinctr 
                p_gphi_crs(ji,1) = p_gphi(ijis,1)
@@ -218,5 +218,5 @@
             ENDDO
          CASE ( 'U', 'F' )
-            DO ji = 2, nlei_crs
+            DO ji = 2, Nie0_crs
                ijis = mis_crs(ji) 
                p_gphi_crs(ji,1) = p_gphi(ijis,1)
@@ -261,7 +261,7 @@
 
       DO jk = 1, jpk    
-         DO ji = 2, nlei_crs
+         DO ji = 2, Nie0_crs
             ijie = mie_crs(ji)
-            DO jj = nldj_crs, nlej_crs
+            DO jj = Njs0_crs, Nje0_crs
                ijje = mje_crs(jj)   ;   ijrs =  mje_crs(jj) - mjs_crs(jj)
                ! Only for a factro 3 coarsening
@@ -374,5 +374,5 @@
       ENDIF
 
-      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+      IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
          IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
             je_2 = mje_crs(2)
@@ -512,5 +512,5 @@
                   ENDIF
          
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -617,5 +617,5 @@
                CASE( 'T', 'W' )
          
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -674,5 +674,5 @@
                CASE( 'V' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -711,5 +711,5 @@
                CASE( 'U' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -782,5 +782,5 @@
                CASE( 'T', 'W' )
          
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -842,5 +842,5 @@
                CASE( 'V' )
 
-                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                 IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -883,5 +883,5 @@
                CASE( 'U' )
 
-                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                 IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -953,5 +953,5 @@
                CASE( 'T', 'W' )
          
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -1013,5 +1013,5 @@
                CASE( 'V' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -1053,5 +1053,5 @@
                CASE( 'U' )
 
-                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                 IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -1158,5 +1158,5 @@
             zsurfmsk(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
 
-            IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+            IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                   je_2 = mje_crs(2)
@@ -1234,5 +1234,5 @@
                CASE( 'T', 'W' )
 
-                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                   IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                       IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                          je_2 = mje_crs(2)
@@ -1285,5 +1285,5 @@
                CASE( 'V' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -1318,5 +1318,5 @@
                CASE( 'U' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -1369,5 +1369,5 @@
                CASE( 'T', 'W' )
   
-                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                   IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                       IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                          je_2 = mje_crs(2)
@@ -1420,5 +1420,5 @@
                CASE( 'V' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -1453,5 +1453,5 @@
                CASE( 'U' )
 
-                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                 IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -1497,5 +1497,5 @@
               CASE( 'T', 'W' )
   
-                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                   IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                       IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                          je_2 = mje_crs(2)
@@ -1548,5 +1548,5 @@
                CASE( 'V' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                  IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         ijje = mje_crs(2)
@@ -1581,5 +1581,5 @@
                CASE( 'U' )
 
-                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                 IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
                         je_2 = mje_crs(2)
@@ -1665,5 +1665,5 @@
        ENDDO
 
-       IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+       IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
           IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
              je_2 = mje_crs(2)
@@ -1808,5 +1808,5 @@
       END SELECT
 
-      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+      IF( Njs0_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
          IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
             je_2 = mje_crs(2)
@@ -1899,57 +1899,53 @@
       ! 2.a Define processor domain
       IF( .NOT. lk_mpp ) THEN
-         nimpp_crs  = 1
-         njmpp_crs  = 1
-         nlci_crs   = jpi_crs
-         nlcj_crs   = jpj_crs
-         nldi_crs   = 1
-         nldj_crs   = 1
-         nlei_crs   = jpi_crs
-         nlej_crs   = jpj_crs
+         nimpp_crs = 1
+         njmpp_crs = 1
+         Nis0_crs  = 1
+         Njs0_crs  = 1
+         Nie0_crs  = jpi_crs
+         Nje0_crs  = jpj_crs
       ELSE
          ! Initialisation of most local variables -
-         nimpp_crs  = 1
-         njmpp_crs  = 1
-         nlci_crs   = jpi_crs
-         nlcj_crs   = jpj_crs
-         nldi_crs   = 1
-         nldj_crs   = 1
-         nlei_crs   = jpi_crs
-         nlej_crs   = jpj_crs
+         nimpp_crs = 1
+         njmpp_crs = 1
+         Nis0_crs  = 1
+         Njs0_crs  = 1
+         Nie0_crs  = jpi_crs
+         Nje0_crs  = jpj_crs
          
         ! Calculs suivant une découpage en j
         DO jn = 1, jpnij, jpni
            IF( jn < ( jpnij - jpni + 1 ) ) THEN
-              nlejt_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
+              nje0all_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
                        &    - AINT( REAL( ( jpjglo - (njmppt(jn+jpni) - 1) ) / nn_facty, wp ) )
            ELSE                                             
-              nlejt_crs(jn) = AINT( REAL(  nlejt(jn) / nn_facty, wp ) ) + 1            
+              nje0all_crs(jn) = AINT( REAL(  nje0all(jn) / nn_facty, wp ) ) + 1            
            ENDIF
-           IF( noso < 0 ) nlejt_crs(jn) = nlejt_crs(jn) + 1             
+           IF( noso < 0 ) nje0all_crs(jn) = nje0all_crs(jn) + 1             
            SELECT CASE( ibonjt(jn) )
               CASE ( -1 )
-                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )  nlejt_crs(jn) = nlejt_crs(jn) + 1
-                nlcjt_crs(jn) = nlejt_crs(jn) + nn_hls
-                nldjt_crs(jn) = nldjt(jn)
+                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
+                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
+                njs0all_crs(jn) = njs0all(jn)
               
               CASE ( 0 )
               
-                nldjt_crs(jn) = nldjt(jn)
-                IF( nldjt(jn) == 1 )  nlejt_crs(jn) = nlejt_crs(jn) + 1
-                nlejt_crs(jn) = nlejt_crs(jn) + nn_hls
-                nlcjt_crs(jn) = nlejt_crs(jn) + nn_hls
+                njs0all_crs(jn) = njs0all(jn)
+                IF( njs0all(jn) == 1 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
+                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
+                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
                 
               CASE ( 1, 2 )
               
-                nlejt_crs(jn) = nlejt_crs(jn) + nn_hls
-                nlcjt_crs(jn) = nlejt_crs(jn)
-                nldjt_crs(jn) = nldjt(jn)
+                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
+                jpjall_crs (jn) = nje0all_crs(jn)
+                njs0all_crs(jn) = njs0all(jn)
                 
               CASE DEFAULT
                  CALL ctl_stop( 'STOP', 'error from crs_dom_def, you should not be there (1) ...' )
            END SELECT
-           IF( nlcjt_crs(jn) > jpj_crs )     jpj_crs = jpj_crs + 1
-
-           IF(nldjt_crs(jn) == 1 ) THEN
+           IF( jpjall_crs(jn) > jpj_crs )     jpj_crs = jpj_crs + 1
+
+           IF(njs0all_crs(jn) == 1 ) THEN
               njmppt_crs(jn) = 1
            ELSE
@@ -1958,40 +1954,40 @@
            
            DO jj = jn + 1, jn + jpni - 1
-              nlejt_crs(jj) = nlejt_crs(jn) 
-              nlcjt_crs(jj) = nlcjt_crs(jn)
-              nldjt_crs(jj) = nldjt_crs(jn)
-              njmppt_crs(jj)= njmppt_crs(jn)
+              nje0all_crs(jj) = nje0all_crs(jn) 
+              jpjall_crs (jj) = jpjall_crs(jn)
+              njs0all_crs(jj) = njs0all_crs(jn)
+              njmppt_crs (jj) = njmppt_crs(jn)
            ENDDO
         ENDDO 
-        nlej_crs  = nlejt_crs(nproc + 1) 
-        nlcj_crs  = nlcjt_crs(nproc + 1)
-        nldj_crs  = nldjt_crs(nproc + 1)
-        njmpp_crs = njmppt_crs(nproc + 1)
+        Nje0_crs  = nje0all_crs(nproc + 1) 
+        jpj_crs   = jpjall_crs (nproc + 1)
+        Njs0_crs  = njs0all_crs(nproc + 1)
+        njmpp_crs = njmppt_crs (nproc + 1)
 
         ! Calcul suivant un decoupage en i
         DO jn = 1, jpni
            IF( jn == 1 ) THEN          
-              nleit_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + nlcit(jn  ) )  / nn_factx, wp) )
+              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) )
            ELSE
-              nleit_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + nlcit(jn  ) )  / nn_factx, wp) ) &
-                 &          - AINT( REAL( ( nimppt(jn-1) - 1 + nlcit(jn-1) )  / nn_factx, wp) )
+              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) ) &
+                 &            - AINT( REAL( ( nimppt(jn-1) - 1 + jpiall(jn-1) )  / nn_factx, wp) )
            ENDIF
 
            SELECT CASE( ibonit(jn) )
               CASE ( -1 )
-                 nleit_crs(jn) = nleit_crs(jn) + nn_hls           
-                 nlcit_crs(jn) = nleit_crs(jn) + nn_hls
-                 nldit_crs(jn) = nldit(jn) 
+                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls           
+                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
+                 nis0all_crs(jn) = nis0all(jn) 
               
               CASE ( 0 )
-                 nleit_crs(jn) = nleit_crs(jn) + nn_hls
-                 nlcit_crs(jn) = nleit_crs(jn) + nn_hls
-                 nldit_crs(jn) = nldit(jn) 
+                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
+                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
+                 nis0all_crs(jn) = nis0all(jn) 
                 
               CASE ( 1, 2 )
-                 IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )  nleit_crs(jn) = nleit_crs(jn) + 1
-                 nleit_crs(jn) = nleit_crs(jn) + nn_hls
-                 nlcit_crs(jn) = nleit_crs(jn)
-                 nldit_crs(jn) = nldit(jn) 
+                 IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )  nie0all_crs(jn) = nie0all_crs(jn) + 1
+                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
+                 jpiall_crs (jn) = nie0all_crs(jn)
+                 nis0all_crs(jn) = nis0all(jn) 
 
               CASE DEFAULT
@@ -2001,15 +1997,15 @@
            nimppt_crs(jn) = ANINT( REAL( (nimppt(jn) + 1 ) / nn_factx, wp ) ) + 1
            DO jj = jn + jpni , jpnij, jpni
-              nleit_crs(jj) = nleit_crs(jn) 
-              nlcit_crs(jj) = nlcit_crs(jn)
-              nldit_crs(jj) = nldit_crs(jn)
-              nimppt_crs(jj)= nimppt_crs(jn)
+              nie0all_crs(jj) = nie0all_crs(jn) 
+              jpiall_crs (jj) = jpiall_crs (jn)
+              nis0all_crs(jj) = nis0all_crs(jn)
+              nimppt_crs (jj) = nimppt_crs (jn)
            ENDDO
          ENDDO 
         
-         nlei_crs  = nleit_crs(nproc + 1) 
-         nlci_crs  = nlcit_crs(nproc + 1)
-         nldi_crs  = nldit_crs(nproc + 1)
-         nimpp_crs = nimppt_crs(nproc + 1)
+         Nie0_crs  = nie0all_crs(nproc + 1) 
+         jpi_crs   = jpiall_crs (nproc + 1)
+         Nis0_crs  = nis0all_crs(nproc + 1)
+         nimpp_crs = nimppt_crs (nproc + 1)
 
          DO ji = 1, jpi_crs
@@ -2043,21 +2039,21 @@
       jpjglo_full = jpjglo
 
-      nlcj_full   = nlcj
-      nlci_full   = nlci
-      nldi_full   = nldi
-      nldj_full   = nldj
-      nlei_full   = nlei
-      nlej_full   = nlej
-      nimpp_full  = nimpp     
-      njmpp_full  = njmpp
+      jpj_full   = jpj
+      jpi_full   = jpi
+      Nis0_full  = Nis0
+      Njs0_full  = Njs0
+      Nie0_full  = Nie0
+      Nje0_full  = Nje0
+      nimpp_full = nimpp     
+      njmpp_full = njmpp
       
-      nlcit_full(:)  = nlcit(:)
-      nldit_full(:)  = nldit(:)
-      nleit_full(:)  = nleit(:)
-      nimppt_full(:) = nimppt(:)
-      nlcjt_full(:)  = nlcjt(:)
-      nldjt_full(:)  = nldjt(:)
-      nlejt_full(:)  = nlejt(:)
-      njmppt_full(:) = njmppt(:)
+      jpiall_full (:) = jpiall (:)
+      nis0all_full(:) = nis0all(:)
+      nie0all_full(:) = nie0all(:)
+      nimppt_full (:) = nimppt (:)
+      jpjall_full (:) = jpjall (:)
+      njs0all_full(:) = njs0all(:)
+      nje0all_full(:) = nje0all(:)
+      njmppt_full (:) = njmppt (:)
       
       CALL dom_grid_crs  !swich de grille
@@ -2073,12 +2069,12 @@
          WRITE(numout,*)
          WRITE(numout,*) ' nproc  = '     , nproc
-         WRITE(numout,*) ' nlci   = '     , nlci
-         WRITE(numout,*) ' nlcj   = '     , nlcj
-         WRITE(numout,*) ' nldi   = '     , nldi
-         WRITE(numout,*) ' nldj   = '     , nldj
-         WRITE(numout,*) ' nlei   = '     , nlei
-         WRITE(numout,*) ' nlej   = '     , nlej
-         WRITE(numout,*) ' nlei_full='    , nlei_full
-         WRITE(numout,*) ' nldi_full='    , nldi_full
+         WRITE(numout,*) ' jpi    = '     , jpi
+         WRITE(numout,*) ' jpj    = '     , jpj
+         WRITE(numout,*) ' Nis0   = '     , Nis0
+         WRITE(numout,*) ' Njs0   = '     , Njs0
+         WRITE(numout,*) ' Nie0   = '     , Nie0
+         WRITE(numout,*) ' Nje0   = '     , Nje0
+         WRITE(numout,*) ' Nie0_full='    , Nie0_full
+         WRITE(numout,*) ' Nis0_full='    , Nis0_full
          WRITE(numout,*) ' nimpp  = '     , nimpp
          WRITE(numout,*) ' njmpp  = '     , njmpp
@@ -2203,9 +2199,9 @@
         mje_crs(:) = mje2_crs(:) 
       ELSE
-        DO jj = 1, nlej_crs
+        DO jj = 1, Nje0_crs
            mjs_crs(jj) = mjs2_crs(mjg_crs(jj)) - njmpp + 1
            mje_crs(jj) = mje2_crs(mjg_crs(jj)) - njmpp + 1
         ENDDO
-        DO ji = 1, nlei_crs
+        DO ji = 1, Nie0_crs
            mis_crs(ji) = mis2_crs(mig_crs(ji)) - nimpp + 1
            mie_crs(ji) = mie2_crs(mig_crs(ji)) - nimpp + 1
@@ -2213,6 +2209,6 @@
       ENDIF
       !
-      nistr = mis_crs(2)  ;   niend = mis_crs(nlci_crs - 1)
-      njstr = mjs_crs(3)  ;   njend = mjs_crs(nlcj_crs - 1)
+      nistr = mis_crs(2)  ;   niend = mis_crs(jpi_crs - 1)
+      njstr = mjs_crs(3)  ;   njend = mjs_crs(jpj_crs - 1)
       !
    END SUBROUTINE crs_dom_def